stages:
- name: eventselection_mc_EvSel
  dependencies: [init]
  scheduler:
    scheduler_type: multistep-stage
    parameters:
      CERN_USER:    {step: init, output: CERN_USER}
      SERVICE_PASS: {step: init, output: SERVICE_PASS}
      configFile:   {step: init, output: configFiles_mc}
      inputList:    {step: init, output: inputLists_mc}
      sampleName:   {step: init, output: sampleNames_mc}
      modBaseAlgo:  {step: init, output: modBaseAlgos_EvSel_mc}
      modConfig:    {step: init, output: modConfigs_mc}
      stepdir:      '{workdir}'
    scatter:
       method: zip
       parameters: [configFile, inputList, sampleName, modBaseAlgo, modConfig]
    step: {$ref: 'steps.yml#/eventselection_list'}
    
- name: eventselection_mc_CP
  dependencies: [init]
  scheduler:
    scheduler_type: multistep-stage
    parameters:
      CERN_USER:    {step: init, output: CERN_USER}
      SERVICE_PASS: {step: init, output: SERVICE_PASS}
      configFile:   {step: init, output: configFiles_mc}
      inputList:    {step: init, output: inputLists_mc}
      sampleName:   {step: init, output: sampleNames_mc}
      modBaseAlgo:  {step: init, output: modBaseAlgos_CP_mc}
      modConfig:    {step: init, output: modConfigs_mc}
      stepdir:      '{workdir}'
    scatter:
       method: zip
       parameters: [configFile, inputList, sampleName, modBaseAlgo, modConfig]
    step: {$ref: 'steps.yml#/eventselection_list'}
    
- name: eventselection_mc_JVT
  dependencies: [init]
  scheduler:
    scheduler_type: multistep-stage
    parameters:
      CERN_USER:    {step: init, output: CERN_USER}
      SERVICE_PASS: {step: init, output: SERVICE_PASS}
      configFile:   {step: init, output: configFiles_mc}
      inputList:    {step: init, output: inputLists_mc}
      sampleName:   {step: init, output: sampleNames_mc}
      modBaseAlgo:  {step: init, output: modBaseAlgos_JVT_mc}
      modConfig:    {step: init, output: modConfigs_mc}
      stepdir:      '{workdir}'
    scatter:
       method: zip
       parameters: [configFile, inputList, sampleName, modBaseAlgo, modConfig]
    step: {$ref: 'steps.yml#/eventselection_list'}
    
- name: eventselection_data
  dependencies: [init]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      CERN_USER:    {step: init, output: CERN_USER}
      SERVICE_PASS: {step: init, output: SERVICE_PASS}
      configFile:   {step: init, output: configFile_data}
      inputList:    {step: init, output: inputList_data}
      sampleName:   {step: init, output: sampleName_data}
      modBaseAlgo:  {step: init, output: modBaseAlgo_data}
      modConfig:    {step: init, output: modConfig_data}
      stepdir:      '{workdir}'
    step: {$ref: 'steps.yml#/eventselection_list'}
    
- name: merge_mc_EvSel
  dependencies: [eventselection_mc_EvSel]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFiles: {stages: eventselection_mc_EvSel, output: histFile, flatten: true}
      outputFile: '{workdir}/hist.root'
      inputBootstraps: {stages: eventselection_mc_EvSel, output: bootstrapFile, flatten: true}
      outputBootstrap: '{workdir}/bootstrap.root'
    step: {$ref: 'steps.yml#/merge'}
    
- name: merge_mc_CP
  dependencies: [eventselection_mc_CP]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFiles: {stages: eventselection_mc_CP, output: histFile, flatten: true}
      outputFile: '{workdir}/hist.root'
      inputBootstraps: {stages: eventselection_mc_CP, output: bootstrapFile, flatten: true}
      outputBootstrap: '{workdir}/bootstrap.root'
    step: {$ref: 'steps.yml#/merge'}
    
- name: merge_mc_JVT
  dependencies: [eventselection_mc_JVT]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFiles: {stages: eventselection_mc_JVT, output: histFile, flatten: true}
      outputFile: '{workdir}/hist.root'
      inputBootstraps: {stages: eventselection_mc_JVT, output: bootstrapFile, flatten: true}
      outputBootstrap: '{workdir}/bootstrap.root'
    step: {$ref: 'steps.yml#/merge'}
    
- name: combine_mc_hist
  dependencies: [merge_mc_EvSel,merge_mc_CP,merge_mc_JVT]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFile_EvSel: {step: merge_mc_EvSel, output: histFile}
      inputFile_CP:    {step: merge_mc_CP,    output: histFile}
      inputFile_JVT:   {step: merge_mc_JVT,   output: histFile}
      outputFile: '{workdir}/merged_mc_hist.root'
    step: {$ref: 'steps.yml#/combine'}
    
- name: combine_mc_bootstrap
  dependencies: [merge_mc_EvSel,merge_mc_CP,merge_mc_JVT]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFile_EvSel: {step: merge_mc_EvSel, output: bootstrapFile}
      inputFile_CP:    {step: merge_mc_CP,    output: bootstrapFile}
      inputFile_JVT:   {step: merge_mc_JVT,   output: bootstrapFile}
      outputFile: '{workdir}/merged_mc_bootstrap.root'
    step: {$ref: 'steps.yml#/combine'}
    
- name: validate_mc_EvSel
  dependencies: [merge_mc_EvSel]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFile: {step: merge_mc_EvSel, output: histFile}
      outputPlot: '{workdir}/plot_mc.pdf'
    step: {$ref: 'steps.yml#/validate'}
    
- name: validate_mc_Full
  dependencies: [combine_mc_hist]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFile: {step: combine_mc_hist, output: combinedFile}
      outputPlot: '{workdir}/plot_mc.pdf'
    step: {$ref: 'steps.yml#/validate'}
    
- name: validate_data
  dependencies: [eventselection_data]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFile: {step: eventselection_data, output: histFile}
      outputPlot: '{workdir}/plot_data.pdf'
    step: {$ref: 'steps.yml#/validate'}
  
- name: validate_data_mc
  dependencies: [merge_mc_EvSel,eventselection_data]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      inputFile_mc:   {step: merge_mc_EvSel, output: histFile}
      inputFile_data: {step: eventselection_data, output: histFile}
      outputPlot: '{workdir}/plot_data_mc.pdf'
    step: {$ref: 'steps.yml#/validate_data_mc'}
  
- name: run_mjb
  dependencies: [combine_mc_hist, combine_mc_bootstrap, eventselection_data]
  scheduler:
    scheduler_type: singlestep-stage
    parameters:
      stepdir                        : '{workdir}'
      workDirMJB                     : '{workdir}/MJBWorkDir'
      inputFile_hist_pythia          : {step: combine_mc_hist,        output: combinedFile}
      inputFile_hist_sherpa          : {step: combine_mc_hist,        output: combinedFile}
      inputFile_hist_data            : {step: eventselection_data,    output: histFile}
      inputFile_bootstrap_pythia     : {step: combine_mc_bootstrap,   output: combinedFile}
      inputFile_bootstrap_sherpa     : {step: combine_mc_bootstrap,   output: combinedFile}
      inputFile_bootstrap_data       : {step: eventselection_data,    output: bootstrapFile}
      validationDir                  : '{workdir}/validationPlots'
    step: {$ref: 'steps.yml#/mjb_processing'}

  
      
 